> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt

# GetTransactionHistory

POST https://api.voximplant.com/platform_api/GetTransactionHistory

Gets the transaction history.

Allowed roles: `Owner`, `Admin`, `Accountant`, `Payer`.

**Example request:** Get the three transactions record from the 2012-01-01 00:00:00 UTC to the 2014-01-01 00:00:00 UTC with the 'gift' or 'money_distribution' types.

Reference: https://docs.voximplant.ai/api-reference/management-api/reference/history/get-transaction-history

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: management-api
  version: 1.0.0
paths:
  /GetTransactionHistory:
    post:
      operationId: get-transaction-history
      summary: GetTransactionHistory
      description: >-
        Gets the transaction history.


        Allowed roles: `Owner`, `Admin`, `Accountant`, `Payer`.


        **Example request:** Get the three transactions record from the
        2012-01-01 00:00:00 UTC to the 2014-01-01 00:00:00 UTC with the 'gift'
        or 'money_distribution' types.
      tags:
        - subpackage_history
      parameters:
        - name: from_date
          in: query
          description: >-
            The from date in the selected timezone in 24-h format: YYYY-MM-DD
            HH:mm:ss
          required: true
          schema:
            type: string
        - name: to_date
          in: query
          description: >-
            The to date in the selected timezone in 24-h format: YYYY-MM-DD
            HH:mm:ss
          required: true
          schema:
            type: string
        - name: transaction_id
          in: query
          description: The transaction ID list separated by semicolons (;)
          required: false
          schema:
            type: array
            items:
              type: integer
        - name: transaction_type
          in: query
          description: >-
            The transaction type list separated by semicolons (;). The following
            values are possible: gift_revoke, resource_charge,
            money_distribution, subscription_charge,
            subscription_installation_charge, card_periodic_payment,
            card_overrun_payment, card_payment, rub_card_periodic_payment,
            rub_card_overrun_payment, rub_card_payment, robokassa_payment, gift,
            promo, adjustment, wire_transfer, us_wire_transfer, refund,
            discount, mgp_charge, mgp_startup, mgp_business, mgp_big_business,
            mgp_enterprise, mgp_large_enterprise, techsupport_charge,
            tax_charge, monthly_fee_charge, grace_credit_payment,
            grace_credit_provision, mau_charge, mau_overrun, im_charge,
            im_overrun, fmc_charge, sip_registration_charge, development_fee,
            money_transfer_to_child, money_transfer_to_parent,
            money_acceptance_from_child, money_acceptance_from_parent,
            phone_number_installation, phone_number_charge,
            toll_free_phone_number_installation, toll_free_phone_number_charge,
            services, user_money_transfer, paypal_payment,
            paypal_overrun_payment, paypal_periodic_payment
          required: false
          schema:
            type: array
            items:
              type: string
        - name: user_id
          in: query
          description: The user ID list separated by semicolons (;)
          required: false
          schema:
            type: array
            items:
              type: integer
        - name: child_account_id
          in: query
          description: >-
            The child account ID list separated by semicolons (;). Use the 'all'
            value to select all child accounts
          required: false
          schema:
            type: array
            items:
              type: integer
        - name: children_transactions_only
          in: query
          description: Whether to get the children account transactions only
          required: false
          schema:
            type: boolean
            default: false
        - name: users_transactions_only
          in: query
          description: Whether to get the users' transactions only
          required: false
          schema:
            type: boolean
            default: false
        - name: desc_order
          in: query
          description: Whether to get records in the descent order
          required: false
          schema:
            type: boolean
        - name: with_total_count
          in: query
          description: Whether to include the 'total_count' and increase performance
          required: false
          schema:
            type: boolean
            default: false
        - name: count
          in: query
          description: The number of returning records. The maximum value is 1000
          required: false
          schema:
            type: integer
            default: 20
        - name: offset
          in: query
          description: >-
            The number of records to skip in the output with a maximum value of
            10000
          required: false
          schema:
            type: integer
            default: 0
        - name: is_uncommitted
          in: query
          description: >-
            Whether to get transactions on hold (transactions for which money is
            reserved but not yet withdrawn from the account)
          required: false
          schema:
            type: boolean
            default: false
        - name: Authorization
          in: header
          description: >-
            Voximplant Management API uses signed JWT tokens generated from your
            service-account private key. Pass the token in the `Authorization`
            header as a Bearer value:


            ```

            Authorization: Bearer $VOXIMPLANT_TOKEN

            ```


            See [Authorization](/api-reference/management-api/authorization) for
            ready-to-copy snippets in bash, Python, Node.js and Go that turn
            your `credentials.json` into a token.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/history_GetTransactionHistory_Response_200
servers:
  - url: https://api.voximplant.com/platform_api
components:
  schemas:
    GetTransactionHistoryPostResponsesContentApplicationJsonSchemaResult:
      oneOf:
        - type: array
          items:
            description: Any type
        - type: integer
      title: GetTransactionHistoryPostResponsesContentApplicationJsonSchemaResult
    history_GetTransactionHistory_Response_200:
      type: object
      properties:
        result:
          $ref: >-
            #/components/schemas/GetTransactionHistoryPostResponsesContentApplicationJsonSchemaResult
        total_count:
          type: integer
          description: The total found transaction count
        timezone:
          type: string
          description: The used timezone. 'Etc/GMT' for example
        count:
          type: integer
          description: The returned transaction count
        history_report_id:
          type: integer
      title: history_GetTransactionHistory_Response_200
  securitySchemes:
    JwtAuth:
      type: http
      scheme: bearer
      description: >-
        Voximplant Management API uses signed JWT tokens generated from your
        service-account private key. Pass the token in the `Authorization`
        header as a Bearer value:


        ```

        Authorization: Bearer $VOXIMPLANT_TOKEN

        ```


        See [Authorization](/api-reference/management-api/authorization) for
        ready-to-copy snippets in bash, Python, Node.js and Go that turn your
        `credentials.json` into a token.

```

## SDK Code Examples

```python Example 1
import requests

url = "https://api.voximplant.com/platform_api/GetTransactionHistory"

querystring = {"from_date":"2012-01-01 00:00:00","to_date":"2014-01-01 00:00:00","transaction_type":"[\"gift\",\"money_distribution\"]","count":"3"}

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript Example 1
const url = 'https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example 1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example 1
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java Example 1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php Example 1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example 1
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example 1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

```python Example 2
import requests

url = "https://api.voximplant.com/platform_api/GetTransactionHistory"

querystring = {"from_date":"2012-01-01 00:00:00","to_date":"2014-01-01 00:00:00","transaction_type":"[\"gift\",\"money_distribution\"]","count":"3"}

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript Example 2
const url = 'https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example 2
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example 2
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java Example 2
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php Example 2
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example 2
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example 2
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/GetTransactionHistory?from_date=2012-01-01+00%3A00%3A00&to_date=2014-01-01+00%3A00%3A00&transaction_type=%5B%22gift%22%2C%22money_distribution%22%5D&count=3")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```